/*
 * Refer to USBLooper.cpp. This software is released under
 * the LGPL (Lesser General Public License). The license:
 * 
 * http://www.gnu.org/copyleft/lesser.html
 *
 * (Notice the application signature for USBLooper contains 'LGPL'.)
 *
 * Copyright (c) 1999 Thomas S. Winzig. All rights reserved.
 *
 * -----------------------------------------------------------------------
 */

#ifndef _USBLOOPERUTIL_H_
#define _USBLOOPERUTIL_H_

// Message 'what's
const uint32 USB_LOOPER_HELLO			= 'USBa'; // Sent by apps wanting alerts
const uint32 USB_LOOPER_GOODBYE			= 'USBb'; // Sent by apps to stop sending alerts
const uint32 USB_DEVICE_CONNECTED		= 'USBc'; // Sent to apps when looper exits or can't be used.
const uint32 USB_DEVICE_DISCONNECTED	= 'USBd'; // A USB device has connected
const uint32 USB_LOOPER_KABOOM			= 'USBe'; // A USB device has disconnected
const uint32 USB_DEVICES_ALREADY_CONNECTED	= 'USBf'; // A request for the list of devices already connected
const uint32 USB_DEVICES				= 'WZGa'; // A private message storing devices that are connected
const uint32 USB_DEVICES_PATHS			= 'WZGb'; // A private message storing devices that are connected

const char* USB_ROOT = "/dev/bus/usb";
const char* USB_LOOPER_SIG = "application/x-vnd.LGPL-USBLooper";

#endif
