#include <Application.h>
#include <Message.h>
#include <Messenger.h>
#include <List.h>

#include <iostream.h>

#include "USBLooperUtil.h"

const char* MY_APP_SIG = "application/x-vnd.Winzig-KameraTest1";

class KameraTest1 : public BApplication
{
	public:
							KameraTest1();
		virtual void		MessageReceived(BMessage *message);
};

KameraTest1::KameraTest1() : BApplication(MY_APP_SIG)
{
	if (be_roster->IsRunning(USB_LOOPER_SIG))
	{
		cerr << "USBLooper is running. Try connecting/disconnecting a" << endl;
		cerr << "USB device to see some action. Press CTRL-C to quit." << endl;
	}
	else
	{
		// A good app would try to locate USBLooper and start it...
		cerr << "USBLooper is not running. Exiting." << endl;
		be_app->PostMessage(B_QUIT_REQUESTED);
	}
	
	BMessenger msgr(USB_LOOPER_SIG);
	msgr.SendMessage(USB_LOOPER_HELLO);
	
// This is the portion that is not working correctly.
// For some reason, when enabled, the USBLooper is not
// consistent when reporting (dis)connects... it seems to
// accumulate them until I quit the test1 application, then
// tries to print them out. If I don't send the following
// message, it works fine. 
/*
	BMessage reply;
	msgr.SendMessage(new BMessage(USB_DEVICES_ALREADY_CONNECTED), &reply);

	// Example usage of reply; this checks for my Kodak camera.
	if (reply.what == USB_DEVICES && reply.HasString("KODAK DC265 ZOOM DIGITAL CA")) 
	{
		cout << "Kodak DC265 Zoom digital camera is connected at ";
		cout << reply.FindString("KODAK DC265 ZOOM DIGITAL CA") << endl;
		// It's possible the same type of device is connected more than once,
		// so you should use reply.GetInfo(...) to find out which one you want.
	}
	else
	{
		cout << "Kodak camera was not already connected." << endl;
	}
*/

}

void KameraTest1::MessageReceived(BMessage *message)
{
	//BMessenger remote_app = message->ReturnAddress();
	switch (message->what)
	{
		// This message indicates an application that wants to
		// receive messages when USB devices connect/disconnect.
		case USB_DEVICE_CONNECTED:
		{
			cout << "Connected:    '" << message->FindString("name") << "' at " << message->FindString("location") << "." << endl;
			break;
		}
		case USB_DEVICE_DISCONNECTED:
		{
			cout << "Disconnected: '" << message->FindString("name") << "' at " << message->FindString("location") << "." << endl;
			break;
		}
		case USB_LOOPER_KABOOM:
		{
			cout << "USBLooper is dead." << endl;
			break;
		}
		default:
		{
			//BApplication::MessageReceived(message);
			break;
		}
	}	
}

int main(void)
{
	KameraTest1 testapp;
	testapp.Run();
	return 0;
}
